/* ROOT(CINT) LinkDef file for the -*- C++ -*- GSL complex number classes.
   (Based on the GNU ANSI C++ Library. Modified by Jacek M. Holeczek, 05.2001.)
   For details about ROOT and CINT see http://root.cern.ch */

#ifdef __MAKECINT__

#pragma link off all typedefs;
#pragma link off all globals;
#pragma link off all functions;
#pragma link off all classes;

#pragma link C++ nestedclass;
#pragma link C++ nestedtypedef;

/* GSL namespace */
#pragma link C++ namespace gsl;

/* Original GSL C complex structs */
#pragma link C++ struct gsl::gsl_complex_float;
#pragma link C++ struct gsl::gsl_complex;
#pragma link C++ struct gsl::gsl_complex_long_double;

/* GSL complex typedefs */
#pragma link C++ typedef gsl::float_complex;
#pragma link C++ typedef gsl::double_complex;
#pragma link C++ typedef gsl::long_double_complex;

/* GSL C++ complex classes */
#pragma link C++ class gsl::fcomplex-!;
#pragma link C++ class gsl::dcomplex-!;
#pragma link C++ class gsl::ldcomplex-!;

/* GSL C++ complex functions */
#pragma link C++ function gsl::imag;
#pragma link C++ function gsl::real;
#pragma link C++ function gsl::operator + ;
#pragma link C++ function gsl::operator - ;
#pragma link C++ function gsl::operator * ;
#pragma link C++ function gsl::operator / ;
#pragma link C++ function gsl::operator == ;
#pragma link C++ function gsl::operator != ;
#pragma link C++ function gsl::abs;
#pragma link C++ function gsl::arg;
#pragma link C++ function gsl::polar;
#pragma link C++ function gsl::conj;
#pragma link C++ function gsl::norm;
#pragma link C++ function gsl::cos;
#pragma link C++ function gsl::cosh;
#pragma link C++ function gsl::exp;
#pragma link C++ function gsl::log;
#pragma link C++ function gsl::pow;
#pragma link C++ function gsl::sin;
#pragma link C++ function gsl::sinh;
#pragma link C++ function gsl::operator >> ;
#pragma link C++ function gsl::operator << ;
#pragma link C++ function gsl::sqrt;

#endif /* ifdef __MAKECINT__ */

/* End of file ComplexLinkDef.h */
