/* ROOT(CINT) LinkDef file for the -*- C++ -*- link to GSL classes.
   Jacek M. Holeczek, 05.2001
   For details about ROOT and CINT see http://root.cern.ch */

#ifdef __MAKECINT__

#pragma link off all typedefs;
#pragma link off all globals;
#pragma link off all functions;
#pragma link off all classes;

#pragma link C++ nestedclass;
#pragma link C++ nestedtypedef;

/* GSL namespace */
#pragma link C++ namespace gsl;

/* Original GSL C complex structs */
#pragma link C++ struct gsl_complex;
#pragma link C++ struct gsl_complex_float;
#pragma link C++ struct gsl_complex_long_double;

/* GSL C++ complex classes */
#pragma link C++ class gsl::dcomplex-!;
#pragma link C++ class gsl::fcomplex-!;
#pragma link C++ class gsl::ldcomplex-!;

/* GSL ANSI complex typedefs */
#pragma link C++ typedef gsl::double_complex;
#pragma link C++ typedef gsl::float_complex;
#pragma link C++ typedef gsl::long_double_complex;

/* GSL C++ block classes */
#pragma link C++ class gsl::dblock-!;
#pragma link C++ class gsl::fblock-!;
//#pragma link C++ class gsl::ldblock-!;
#pragma link C++ class gsl::iblock-!;
#pragma link C++ class gsl::uiblock-!;
//#pragma link C++ class gsl::liblock-!;
//#pragma link C++ class gsl::luiblock-!;
//#pragma link C++ class gsl::siblock-!;
//#pragma link C++ class gsl::suiblock-!;
#pragma link C++ class gsl::cblock-!;
#pragma link C++ class gsl::ucblock-!;
#pragma link C++ class gsl::dcblock-!;
#pragma link C++ class gsl::fcblock-!;
#pragma link C++ class gsl::ldcblock-!;

/* GSL C++ functions */
#pragma link C++ function gsl::imag;
#pragma link C++ function gsl::real;
#pragma link C++ function gsl::operator + ;
#pragma link C++ function gsl::operator - ;
#pragma link C++ function gsl::operator * ;
#pragma link C++ function gsl::operator / ;
#pragma link C++ function gsl::operator == ;
#pragma link C++ function gsl::operator != ;
#pragma link C++ function gsl::abs;
#pragma link C++ function gsl::arg;
#pragma link C++ function gsl::polar;
#pragma link C++ function gsl::conj;
#pragma link C++ function gsl::norm;
#pragma link C++ function gsl::cos;
#pragma link C++ function gsl::cosh;
#pragma link C++ function gsl::exp;
#pragma link C++ function gsl::log;
#pragma link C++ function gsl::pow;
#pragma link C++ function gsl::sin;
#pragma link C++ function gsl::sinh;
#pragma link C++ function gsl::operator >> ;
#pragma link C++ function gsl::operator << ;
#pragma link C++ function gsl::sqrt;

#endif /* ifdef __MAKECINT__ */

/* End of file gslLinkDef.h */
