//
// $Id$
//
#ifndef HACK_H
#define HACK_H
//
// FIXME: Hack to allow nested classes.
// If we are in CINT, then we do not want the operator 
//
//    friend TBuffer &operator>>(TBuffer &buf, Nested *&obj);
//
// In the class declaration, since CINT understands this as 
// 
//    TBuffer &Foo::operator>>(TBuffer &buf, Top::Nested *&obj);
//
// which, FAIK, we cannot implement in any possible way. 
//
// I'm not sure this is a mistake in CINT, or in ROOT i.e., the
// definition of ClassDef.  I tried to figure out what the standard
// says on this (Section 9.7, paragraph 4), but I couldn't really
// decifer it.  Someone more knowledgable on the standard should have
// a look at it. 
// 
// Perhaps ROOT should take out the line 
//
//    friend TBuffer &operator>>(TBuffer &buf, name *&obj);
//
// from ClassDef, since the actual implmentation doesn't seem to need
// to have access the private and protected members any way.  However,
// then one must find a way to get external linkage for 
// 
//    friend TBuffer &operator>>(TBuffer &buf, name *&obj);
//
// and perhaps to get CINT to recognise it. 
// 
#ifndef __CINT__
#define ClassDef2(name,id) ClassDef(name,id)
#else 
#define ClassDef2(name,id) \
private: \
   static TClass *fgIsA; \
public: \
   static  TClass*     Class(); \
   static  const char* Class_Name(); \
   static  Version_t   Class_Version() { return id; } \
   static  void        Dictionary(); \
   virtual TClass*     IsA() const { return name::Class(); } \
   virtual void        ShowMembers(TMemberInspector &insp, char *parent); \
   virtual void        Streamer(TBuffer &b); \
   void                StreamerNVirtual(TBuffer &b) {name::Streamer(b);} \
   _ClassInit_(name) \
   static const char*  DeclFileName() { return __FILE__; } \
   static int          DeclFileLine() { return __LINE__; } \
   static const char*  ImplFileName(); \
   static int          ImplFileLine();
#endif

#endif
