//
// $Id$
//
#include <TROOT.h>
#include <TClass.h>
#include <TList.h>
#include <iostream>
#include "classes.h"

TROOT myRoot("myRoot", "My ROOT");

int main(int argc, char** argv) 
{
  // An object of a class with a nested class 
  Top* top = new Top;

  // I'd like to see some information on the nested class please. 
  TClass* nestedCl = (Top::Nested::Class());
  nestedCl->Print();
  // In particular if it inherits from TObject. 
  cout << (nestedCl->InheritsFrom("TObject") ? "Does" : "Doesn;t") 
       << " inherit from TObject" << endl;
  
  // Try to add 10 object of the nested class to internal
  // TClonesArray. 
  for (int i = 0; i < 10; i++) {
    cout << "Adding a nsted class at " << top->GetN() << endl;
    top->AddNested(i + 10);
  }
  
  // See if we really got the 10 objects into the array 
  for (int i = 0; i < 10; i++) {
    cout << "Nested class at " << i << ": " << flush;
    cout << top->GetNested(i)->GetNested() << endl;
  }
  
  return 0;
}

  
