//example of macro illustrating how to sort histograms by their bin contents
void hsort()
{
   //create 100 histograms and fill them with a gaus distribution
   const Int_t nh = 100;
   TH1F *h[nh];
   Int_t i,j;
   char name[8];
   for (i=0;i<nh;i++) {
      sprintf(name,"h%d",i);
      h[i] = new TH1F(name,"",100,-4,4);
      for (j=0;j<10000;j++) h[i]->Fill(gRandom->Gaus(0,1));
   }

   //get maximum of each histogram into a local array
   Float_t hmax[nh];
   for (i=0;i<nh;i++) hmax[i] = h[i]->GetMaximum();
   
   //sort histograms. Store in a TObjArray
   Int_t index[nh];
   TMath::Sort(nh,hmax,index);
   TObjArray *hlist = new TObjArray(nh); //will contain sorted histograms
   for (i=0;i<nh;i++) {
      printf("i=%d, index=%d, max=%f\n",i,index[i],hmax[index[i]]);
      hlist->Add(h[i]); 
   }
}      
            
