ObjSuf        = obj
SrcSuf        = cpp
ExeSuf        = .exe
DllSuf        = dll
OutPutOpt     = /out:
RM            = del/q

# Win32 system with Microsoft Visual C/C++
APPVER = 4.0
TARGETOS = BOTH
!include <win32.mak>
CC            = $(cc)
CXX           = $(cc)

CXXFLAGS      = $(cvarsdll) /O2 /G5 /MD -D_WINDOWS -I$(ROOTSYS)/include
CXXDEBUG      = /Zi -Fd$*.pdb 
LD            = $(link)
LDFLAGS       = $(conlflags)
SOFLAGS       = $(dlllflags:/PDB:NONE=)
LDDEBUG       = -PDB:$*.pdb 
ROOTLIBS      = $(ROOTSYS)/lib/*.lib
LIBS          = $(ROOTLIBS) $(guilibsdll) MSVCIRT.LIB
LIBSALL       = $(ROOTLIBS)

HDRS     = TMLPexample.h TMLPoption.h TMLPfit.h
SRCS     = TMLPexample.cpp TMLPoption.cpp TMLPfit.cpp mlpfitdict.cpp
OBJS     = TMLPexample.obj TMLPoption.obj TMLPFit.obj mlpfitdict.obj
PROGRAM  = Root_MLPfit.$(DllSuf)
all:        $(PROGRAM)
$(PROGRAM): $(OBJS)
	@echo "Linking $(PROGRAM) ..."
	$(LD) $(LDDEBUG) $(SOFLAGS) $(OBJS) $(LIBS) $(OutPutOpt)$(PROGRAM)
	@echo "Root_MLPfit.dll done"
clean:
	@$(RM) $(OBJS) mlpfitdict*  Root_MLPfit.dll
###

TMLPexample.obj: TMLPexample.h
TMLPoption.obj:  TMLPoption.h
TMLPfit.obj: MLPfit.h TMLPexample.h TMLPoption.h TMLPfit.h

mlpfitdict.cpp: $(HDRS)
	@echo "Deleting dictionary..."
	@$(RM) mlpfitdict.h mlpfitdict.cpp mlpfitdict.obj
	@echo "Generating dictionary ..."
	@$(ROOTSYS)\bin\rootcint mlpfitdict.cpp -c $(HDRS) LinkDef.h

.$(SrcSuf).$(ObjSuf):
        $(CXX) $(CXXFLAGS) $(CXXDEBUG) -c $<

